datablock TSShapeConstructor( NewHorseDts )
{
	baseShape  = "./horse.dts";
	sequence0  = "./h_root.dsq root";

	sequence1  = "./h_run.dsq run";
	sequence2  = "./h_run.dsq walk";
	sequence3  = "./h_back.dsq back";
	sequence4  = "./h_side.dsq side";

	sequence5  = "./h_root.dsq crouch";
	sequence6  = "./h_run.dsq crouchRun";
	sequence7  = "./h_back.dsq crouchBack";
	sequence8  = "./h_side.dsq crouchSide";

	sequence9  = "./h_look.dsq look";
	sequence10 = "./h_root.dsq headside";
	sequence11 = "./h_root.dsq headUp";

	sequence12 = "./h_jump.dsq jump";
	sequence13 = "./h_jump.dsq standjump";
	sequence14 = "./h_root.dsq fall";
	sequence15 = "./h_root.dsq land";

	sequence16 = "./h_armAttack.dsq armAttack";
	sequence17 = "./h_root.dsq armReadyLeft";
	sequence18 = "./h_root.dsq armReadyRight";
	sequence19 = "./h_root.dsq armReadyBoth";
	sequence20 = "./h_spearReady.dsq spearready";  
	sequence21 = "./h_root.dsq spearThrow";

	sequence22 = "./h_root.dsq talk";  

	sequence23 = "./h_death1.dsq death1"; 
	
	sequence24 = "./h_shiftUp.dsq shiftUp";
	sequence25 = "./h_shiftDown.dsq shiftDown";
	sequence26 = "./h_shiftAway.dsq shiftAway";
	sequence27 = "./h_shiftTo.dsq shiftTo";
	sequence28 = "./h_shiftLeft.dsq shiftLeft";
	sequence29 = "./h_shiftRight.dsq shiftRight";
	sequence30 = "./h_rotCW.dsq rotCW";
	sequence31 = "./h_rotCCW.dsq rotCCW";

	sequence32 = "./h_root.dsq undo";
	sequence33 = "./h_plant.dsq plant";

	sequence34 = "./h_root.dsq sit";

	sequence35 = "./h_root.dsq wrench";

	sequence36 = "./h_root.dsq activate";
	sequence37 = "./h_root.dsq activate2";

	sequence38 = "./h_root.dsq leftrecoil";
};    

datablock AudioProfile( NewHorseJumpSound )
{
	fileName = "./jump.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile( NewHorseTrotSound )
{
	fileName = "./trot.wav";
	description = AudioCloseLooping3d;
	preload = true;
};

datablock AudioProfile( NewHorseGallopSound )
{
	fileName = "./gallop.wav";
	description = AudioCloseLooping3d;
	preload = true;
};

datablock AudioProfile( NewHorseNeigh1Sound : NewHorseJumpSound )
{
	fileName = "./neigh1.wav";
};

datablock AudioProfile( NewHorseNeigh2Sound : NewHorseJumpSound )
{
	fileName = "./neigh2.wav";
};

datablock AudioProfile( NewHorseNeigh3Sound : NewHorseJumpSound )
{
	fileName = "./neigh3.wav";
};

datablock AudioProfile( NewHorseNeigh4Sound : NewHorseJumpSound )
{
	fileName = "./neigh4.wav";
};

datablock AudioProfile( NewHorseSnort1Sound : NewHorseJumpSound )
{
	fileName = "./snort1.wav";
};

datablock AudioProfile( NewHorseSnort2Sound : NewHorseJumpSound )
{
	fileName = "./snort2.wav";
};

datablock AudioProfile( NewHorseSnort3Sound : NewHorseJumpSound )
{
	fileName = "./snort3.wav";
};

datablock AudioProfile( NewHorseSnort4Sound : NewHorseJumpSound )
{
	fileName = "./snort4.wav";
};

datablock DebrisData( NewHorseDebris )
{
	explodeOnMaxBounce = false;

	elasticity = 0.15;
	friction = 0.5;

	lifetime = 4.0;
	lifetimeVariance = 0.0;

	minSpinSpeed = 40;
	maxSpinSpeed = 600;

	numBounces = 5;
	bounceVariance = 0;

	staticOnMaxBounce = true;
	gravModifier = 1.0;

	useRadiusMass = true;
	baseRadius = 1;

	velocity = 20.0;
	velocityVariance = 12.0;
};             

datablock PlayerData( NewHorseArmor )
{
	renderFirstPerson = false;
	emap = false;
	
	className = Armor;
	shapeFile = "./horse.dts";
	cameraMaxDist = 3;
	cameraTilt = 0.1;//0.174 * 2.5; //~25 degrees
	cameraVerticalOffset = 3;
	cameraHorizontalOffset = 1;
	  
	cameraDefaultFov = 90.0;
	cameraMinFov = 5.0;
	cameraMaxFov = 120.0;

	aiAvoidThis = true;

	minLookAngle = -1;
	maxLookAngle = 1;
	maxFreelookAngle = 3.0;

	mass = 90;
	drag = 0.1;
	density = 0.7;
	maxDamage = 250;
	maxEnergy = 300;
	repairRate = 0.33;

	rechargeRate = 0.2;

	runForce = 28 * 100;
	runEnergyDrain = 0;
	minRunEnergy = 0;

	maxForwardSpeed = 20;
	maxBackwardSpeed = 6;
	maxSideSpeed = 1;

	maxForwardCrouchSpeed = 12;
	maxBackwardCrouchSpeed = 6;
	maxSideCrouchSpeed = 1;

	maxForwardProneSpeed = 0;
	maxBackwardProneSpeed = 0;
	maxSideProneSpeed = 0;

	maxForwardWalkSpeed = 9;
	maxBackwardWalkSpeed = 3;
	maxSideWalkSpeed = 0.5;

	maxUnderwaterForwardSpeed = 8.4;
	maxUnderwaterBackwardSpeed = 7.8;
	maxUnderwaterSideSpeed = 7.8;

	jumpForce = 900; //8.3 * 90;
	jumpEnergyDrain = 1;
	minJumpEnergy = 0.01;
	jumpDelay = 1;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	minImpactSpeed = 250;
	speedDamageScale = 3.8;

	boundingBox			= vectorScale("2.5 2.5 2.4", 4);
	crouchBoundingBox	= vectorScale("2.5 2.5 2.4", 4);
	
	pickupRadius = 0.75;
	
	// Foot Prints
	//decalData   = HorseFootprint;
	//decalOffset = 0.25;
	
	jetEmitter = "";
	jetGroundEmitter = "";
	jetGroundDistance = 4;
  
	footPuffEmitter = LightPuffEmitter;
	footPuffNumParts = 10;
	footPuffRadius = 0.25;

	dustEmitter = LiftoffDustEmitter;

	splash = PlayerSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 0.1;
	splashEmitter[0] = PlayerFoamDropletsEmitter;
	splashEmitter[1] = PlayerFoamEmitter;
	splashEmitter[2] = PlayerBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;

	// Controls over slope of runnable/jumpable surfaces
	runSurfaceAngle  = 85;
	jumpSurfaceAngle = 86;

	minJumpSpeed = 20;
	maxJumpSpeed = 30;

	horizMaxSpeed = 68;
	horizResistSpeed = 33;
	horizResistFactor = 0.35;

	upMaxSpeed = 80;
	upResistSpeed = 25;
	upResistFactor = 0.3;
	
	footstepSplashHeight = 0.35;

	//NOTE:  some sounds commented out until wav's are available

	JumpSound			= NewHorseJumpSound;

	// Footstep Sounds
//   FootSoftSound        = HorseFootFallSound;
//   FootHardSound        = HorseFootFallSound;
//   FootMetalSound       = HorseFootFallSound;
//   FootSnowSound        = HorseFootFallSound;
//   FootShallowSound     = HorseFootFallSound;
//   FootWadingSound      = HorseFootFallSound;
//   FootUnderwaterSound  = HorseFootFallSound;
	//FootBubblesSound     = FootLightBubblesSound;
	//movingBubblesSound   = ArmorMoveBubblesSound;
	//waterBreathSound     = WaterBreathMaleSound;

	//impactSoftSound      = ImpactLightSoftSound;
	//impactHardSound      = ImpactLightHardSound;
	//impactMetalSound     = ImpactLightMetalSound;
	//impactSnowSound      = ImpactLightSnowSound;
	
	impactWaterEasy      = Splash1Sound;
	impactWaterMedium    = Splash1Sound;
	impactWaterHard      = Splash1Sound;
	
	groundImpactMinSpeed    = 10.0;
	groundImpactShakeFreq   = "4.0 4.0 4.0";
	groundImpactShakeAmp    = "1.0 1.0 1.0";
	groundImpactShakeDuration = 0.8;
	groundImpactShakeFalloff = 10.0;
	
	//exitingWater         = ExitingWaterLightSound;

	// Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "New Horse";
	rideable = true;
	lookUpLimit = 0.6;
	lookDownLimit = 0.2;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	numMountPoints = 2;
	mountThread[2] = "armReadyBoth";
	mountNode[0] = 2;
	mountThread[4] = "sit";
	mountNode[1] = 4;
};

function NewHorseArmor::onAdd(%this, %obj)
{
	Parent::onAdd(%this, %obj);

	%obj.mountVehicle = true;
	%obj.setRepairRate(0);

	//0 female, 1 male
	%obj.gender = getRandom(0, 1);

	if(%obj.gender)
	{
		%obj.setScale("1.05 1.05 1.05");
	}

	%obj.schedule(100, saveColor);

	%this.horseSoundCheck(%obj);
	%this.horseSnortLoop(%obj);

	%obj.spawnTime = $Sim::Time;
}

function NewHorseArmor::onRemove(%this, %obj)
{
	for(%a = 1; %a <= %obj.offspringCount; %a++)
	{
		%foal = %obj.offspring[%a];

		if(isObject(%foal))
		{
			%this.playNeigh(%foal);
			%foal.scheduleNoQuota(getRandom(1000, 2000), delete);
		}
	}

	Parent::onRemove(%this, %obj);
}

function AIPlayer::saveColor(%obj)
{
	if(isObject(%obj.spawnBrick))
	{
		%obj.spawnBrick.setRecolorVehicle(true);
		%obj.bodyColor = getColorIDTable(%obj.spawnBrick.colorID);
	}
}

function NewHorseArmor::horseSoundCheck(%this, %obj)
{
	if(!isObject(%obj))
	{
		return;
	}

	%speed = vectorLen(%obj.getVelocity());

	if(%speed > 2 && !%obj.isJumping() && !%obj.hIsFalling() && !%obj.isJumping)
	{
		if(%speed < 8)
		{
			%obj.playAudio(0, NewHorseTrotSound);
		}
		else
		{
			%obj.playAudio(0, NewHorseGallopSound);
		}
	}
	else
	{
		%obj.stopAudio(0);
	}

	if(%obj.hIsFalling())
	{
		%obj.isJumping = false;
	}

	%this.schedule(250, horseSoundCheck, %obj);
}

function NewHorseArmor::horseSnortLoop(%this, %obj)
{
	if(!isObject(%obj))
	{
		return;
	}

	if(!%obj.getMountedObject(0))
	{
		%this.playSnort(%obj);
	}

	%this.schedule(getRandom(5000, 10000), horseSnortLoop, %obj);
}

function NewHorseArmor::playNeigh(%this, %obj)
{
	if(%obj.getState() $= "Dead") return;

	if($Sim::Time - %obj.lastNeigh < 3) return;

	%obj.playThread(0, plant);

	%obj.playAudio(1, "NewHorseNeigh" @ getRandom(1, 4) @ "Sound");
	%obj.lastNeigh = $Sim::Time;
}

function NewHorseArmor::playSnort(%this, %obj)
{
	if(%obj.getState() $= "Dead") return;

	%obj.playThread(0, plant);

	%obj.playAudio(1, "NewHorseSnort" @ getRandom(1, 4) @ "Sound");

	if(!getRandom(0, 1) && !isObject(%obj.getAimObject()))
	{
		%obj.horsewander(getRandom(1000, 2000));
	}
	else if(!getRandom(0, 3))
	{
		%obj.horseTryBreed();
	}
}

function NewHorseArmor::horseFollow(%this, %obj, %val, %target, %minDistance)
{
	if(%minDistance $= "")
	{
		%minDistance = 6;
	}

	%obj.followMinDistance = %minDistance;

	%this.leashed = !%val;
	if(!%val)
	{
		cancel(%obj.horseFollowTick);
		%obj.horseFollowTick = %obj.schedule(250, setMoveY, 0);
	
		%obj.clearAim();
		%obj.setMoveX(0);
		%obj.setMoveY(0);
		
		return;
	}

	if( isObject( %target ) )
		%obj.setAimObject( %target );
		%obj.horseFollowTick();
}

function NewHorseArmor::onHorseClicked(%this, %obj, %player)
{
	if(%obj.mating)
	{
		return;
	}

	if(%obj.getAimObject() == %player)
	{
		%this.horseFollow(%obj, 0);
		if(isObject(HateImage)) %obj.emote(HateImage);
	}
	else if(%player.getObjectMount() != %obj)
	{
		%this.horseFollow(%obj, 1, %player);
		if(isObject(LoveImage)) %obj.emote(LoveImage);
	}

	%this.playNeigh(%obj);
}

function AIPlayer::horseFollowTick(%obj)
{
	cancel(%obj.horseFollowTick);

	%target = %obj.getAimObject();
	if(!isObject(%target))
	{
		return;
	}

	%dist = VectorDist(%obj.getPosition(), %target.getPosition());

	if(%dist > %obj.followMinDistance && %target.getObjectMount() != %obj)
	{
		%obj.setMoveY(%dist / 32);
		%obj.horseAvoidObstacle();
	}
	else
	{
		%obj.setMoveX(0);
		%obj.setMoveY(0);
	}

	%obj.horseFollowTick = %obj.schedule(100, horseFollowTick);
}

function AIPlayer::horseReturnTick(%obj)
{
	cancel(%obj.horseReturnTick);

	%target = %obj.spawnBrick;
	if(!isObject(%target))
	{
		return;
	}

	%dist = VectorDist(%obj.getPosition(), %target.getPosition());

	if(%dist > 6)
	{
		%obj.horseAvoidObstacle();
	}
	else
	{
		return;
	}

	%obj.horseReturnTick = %obj.schedule(100, horseReturnTick);
}

//the controversial fuction that checks for a potential mate
function AIPlayer::horseTryBreed(%obj)
{
	initContainerRadiusSearch(%obj.getPosition(), 10, $TypeMasks::PlayerObjectType);

	if($Sim::Time - %obj.lastBreedTime < 300 || %obj.foal || %obj.mating)
	{
		return;
	}

	while(%mate = containerSearchNext())
	{
		//No interspecies mating
		if(%mate.getClassName() !$= "AIPlayer")
		{
			continue;
		}

		//No interspecies mating
		if(%mate.getDatablock().getName() !$= "NewHorseArmor")
		{
			continue;
		}

		//No mating with someone who just mated or is currently mating (lol wut)
		if($Sim::Time - %mate.lastBreedTime < 300 || %mate.mating)
		{
			return;
		}

		//No mating with children
		if(%mate.foal)
		{
			continue;
		}

		//Has to be opposite sex
		//Don't mean be homophobic, but it's impossible
		if(%mate.gender == %obj.gender)
		{
			continue;
		}

		//No mating with our mom
		if(%obj.mom !$= "" && %mate == %obj.mom)
		{
			continue;
		}

		//No mating with our dad
		if(%obj.dad !$= "" && %mate == %obj.dad)
		{
			continue;
		}

		//No mating with our sibling
		if(%mate.mom !$= "" && %obj.mom !$= "" && %mate.mom == %obj.mom)
		{
			continue;
		}

		//No mating with our sibling
		if(%mate.dad !$= "" && %obj.dad !$= "" && %mate.dad == %obj.dad)
		{
			continue;
		}

		//Everything seems legit. Make a baby already!
		%obj.horseStartMate( %mate );
		return;
	}
}

function AIPlayer::horseStartMate( %obj, %mate )
{
	if(!isObject(%mate))
	{
		return;
	}

	%male = (%obj.gender ? %obj : %mate);
	%female = (%obj.gender ? %mate : %obj);

	if(!isObject(%male) || !isObject(%female))
	{
		return;
	}

	%male.getDatablock().horseFollow(%male, 1, %female, 3);
	%female.getDatablock().horseFollow(%female, 1, %male, 3);

	if(isObject(LoveImage))
	{
		%male.emote(LoveImage);

		%female.emote(LoveImage);
	}

	%male.mating = true;
	%female.mating = true;

	%time = $Sim::Time;
	%male.lastBreedTime = %time;
	%female.lastBreedTime = %time;

	%male.getDatablock().playNeigh(%male);
	%female.getDatablock().playNeigh(%female);
	%male.schedule(getRandom(1500, 3000), horseContinueBreed, %female);
}

function AIPlayer::horseContinueBreed( %male, %female )
{
	if(!isObject(%male) || !isObject(%female))
	{
		return;
	}

	%male.mating = true;
	%female.mating = true;
	%male.getDatablock().horseFollow(%male, 1, %female, 3);
	%female.getDatablock().horseFollow(%female, 1, %male, 3);
	%female.setAimVector(%male.getForwardVector());

	%male.playThread(0, jump);
	%female.playThread(0, walk);

	if(isObject(LoveImage))
	{
		%male.emote(LoveImage);

		%female.emote(LoveImage);
	}

	%male.getDatablock().playNeigh(%male);
	%female.getDatablock().playNeigh(%female);
	%male.schedule(getRandom(1500, 3000), ( !getRandom(0, 1) ? horseContinueBreed : horseStopBreed ), %female);
}

function AIPlayer::horseStopBreed( %male, %female )
{
	if(!isObject(%male) || !isObject(%female))
	{
		return;
	}

	%color = getHorseOffspringColor( %female.bodyColor, %male.bodyColor );

	schedule(getRandom(3000, 10000), 0, birthHorseOffspring, %female, %male, %color);

	%male.getDatablock().horseFollow(%male, 0);
	%female.getDatablock().horseFollow(%female, 0);

	%male.horseWander(4000);
	%female.horseWander(2000);

	%male.mating = false;
	%female.mating = false;

	%male.getDatablock().playNeigh(%male);
	%female.getDatablock().playNeigh(%female);
}

function getHorseOffspringColor( %mom, %dad )
{
	if(!getRandom(0, 10))
	{
		return getWords(%mom, 0, 2);
	}
	else if(!getRandom(0, 10))
	{
		return getWords(%dad, 0, 2);
	}
	for(%a = 0; %a < 3; %a++)
	{
		%moms = getWord(%mom, %a);
		%dads = getWord(%dad, %a);

		if(%moms > %dads)
		{
			%small = %dads;
			%big = %moms;
		}
		else
		{
			%small = %moms;
			%big = %dads;
		}

		%new = ( (%big - %small) / 2 ) + %small;

		%offspring = trim(%offspring SPC %new);
	}

	echo(%offspring);
	return %offspring;
}

function birthHorseOffspring( %mom, %dad, %color )
{
	if(!isObject(%mom))
	{
		return;
	}

	%foal = new AIPlayer()
	{
		datablock = NewHorseArmor;

		mom = %mom;
		dad = (isObject(%dad) ? %dad : "");

		spawnBrick = %mom.spawnBrick;
		brickGroup = %mom.brickGroup;

		foal = true;
	};

	%foal.setNodeColor("body", %color SPC 1);

	%foal.setTransform( %mom.getPosition() );
	%foal.setScale(VectorSub(%foal.getScale(), "0.42 0.42 0.42"));

	%mom.offspring[%mom.offspringCount++] = %foal;

	%xRand = getrandom(-10,10);
	%yRand = getrandom(-10,10);
	%fPos = %foal.horseReturnForwardBackPos(-6);

	%foal.setMoveDestination( vectoradd(%fPos, %xRand SPC %yRand SPC 0) );

	%foal.schedule(getRandom(1000, 3000), onFoalJustBorn);
}

function AIPlayer::onFoalJustBorn(%foal)
{
	%mom = %foal.mom;

	if(!isObject(%mom))
	{
		return;
	}

	%foal.getDatablock().horseFollow(%foal, 1, %mom, 3);

	%mom.getDatablock().horseFollow(%mom, 1, %foal, 3);

	if(isObject(LoveImage))
	{
		%foal.emote(LoveImage);

		%mom.emote(LoveImage);
	}

	%foal.schedule(getRandom(6000, 8000), afterFoalJustBorn);
}

function AIPlayer::afterFoalJustBorn(%foal)
{
	%mom = %foal.mom;

	if(!isObject(%mom))
	{
		return;
	}

	%foal.getDatablock().horseFollow(%foal, 0);

	%mom.getDatablock().horseFollow(%mom, 0);

	if(isObject(LoveImage))
	{
		%foal.emote(LoveImage);

		%mom.emote(LoveImage);
	}

	%foal.schedule(getRandom(1000, 2000), foalMoveFromMom);
}

function AIPlayer::foalMoveFromMom(%foal)
{
	%mom = %foal.mom;

	if(!isObject(%mom))
	{
		return;
	}

	%foalPos = %foal.getPosition();
	%momPos = %mom.getPosition();

	%foal.horseWander(4000);
	%mom.horseWander(3000);

	%foal.schedule(getRandom(1000, 2000), foalGrowTick);
}

function AIPlayer::foalGrowTick(%foal)
{
	cancel(%foal.foalGrowTick);

	if(%foal.growCount >= 6)
	{
		%foal.foal = false;
		%foal.getDatablock().playNeigh(%foal);
		return;
	}

	%foal.setScale( VectorAdd(%foal.getScale(), "0.07 0.07 0.07") );
	%foal.growCount++;

	%foal.foalGrowTick = %foal.schedule(getRandom(16000, 22000), foalGrowTick);
}

function clearIndependantHorses()
{

}

function AIPlayer::horseClearMovement(%obj)
{
	%obj.clearMoveY();
	%obj.clearMoveX();
	%obj.setImageTrigger(0,0);
	%obj.setImageTrigger(1,0);

	%obj.setJumping(0);
	%obj.setCrouching(0);

	%obj.setMoveObject("");
	%obj.clearAim();
	%obj.maxYawSpeed = 10;
	%obj.maxPitchSpeed = 10;
	
	%obj.setHeadAngleSpeed( 0.5 );
	%obj.setHeadAngle( 0 );
}

function getRandomF(%min, %max, %neg)
{
	// for now take the min max and scale up by 100, need to change the function to only accept 0.0 to 1.0
	%min = %min*100;
	%max = %max*100;
	
	%n = getRandom( %min, %max );
	%n = %n/1000;
	
	// 50/50 for negative
	if( %neg && getRandom( 0, 1 ) )
		%n = %n-%n*2;
		
	return %n;
}

function AIPlayer::horseWander(%obj, %time)
{
	if($Sim::Time - %obj.spawnTime < 2 || %obj.spawnTime $= "")
	{
		return;
	}

	cancel(%obj.wanderCancel);

	%obj.maxYawSpeed = getRandom(3,10);
	%obj.maxPitchSpeed = getRandom(3,10);

	%maxSpeed = 3;
	%halfSpeed = %maxSpeed/2;
	
	// %speed = getRandomF(5,8);
	%speed = getRandomF( %halfSpeed , %maxSpeed );
	
	// small chance of us walking backwards
	if( !getRandom(0,5) ) 
		%speed = -%speed;
		
	%obj.setMoveY(%speed);

	%p[0] = "";
	%p[1] = "-";

	%x = getRandomF(0,10,1);

	%y = getRandomF(0,10,1);
	
	%z = getRandomF(0,3,1);

	%vec = %x SPC %y SPC %z;
	// %obj.hSetAimVector( %vec );
	%obj.setAimVector( %vec );

	%obj.horseAvoidObstacle();

	%scale = getWord(%obj.getScale(),0);

	%returnDist = %scale*24;
	%pos = %obj.getPosition();

	if( VectorDist( %pos, %obj.spawnBrick.getPosition() ) > %returnDist && !(isObject(%obj.lastRider) && VectorDist( %pos, %obj.lastRider.getPosition() ) < %returnDist ) )
	{
		if(!isObject(%obj.spawnBrick))
		{
			//All is lost. Mom is dead.
			%obj.delete();
			//Call quits and kill ourselves.
			return;
		}

		%brickPos = %obj.spawnBrick.getPosition();
		%brickZ = getWord( %brickPos, 2 );
		%objZ = getWord(%obj.getPosition(), 2);
		
		if( vectorDist(%pos,%brickPos) <= 6*%scale )
			%obj.setMoveY( 0.2 );		
		
		%obj.clearAim();
		%obj.setMoveDestination( %brickPos );

		%obj.horseReturnTick();
	}

	%obj.wanderCancel = %obj.schedule(%time, horseClearMovement);
}

function AIPlayer::horseJump( %obj, %time )
{
	if( !strlen( %time ) )
		%time = 1000;

	%obj.setJumping(1);
	%obj.scheduleNoQuota(%time,setJumping,0);
}

function AIPlayer::horseReturnForwardBackPos(%obj, %a)
{
	%vec = %obj.getForwardVector();
	%sVec = vectorScale(%vec,%a);
	
	%pos = vectorAdd(%obj.getPosition(), %sVec);
	return %pos;
}

function AIPlayer::horseAvoidObstacle( %obj )
{
	%data = %obj.getDataBlock();
	
	%leftBlocked = 0;
	%rightBlocked = 0;
	%forwardBlocked = 0;
	%jumpBlocked = 0;
	%canJump = 1;
	%avoided = 0;
	
	if(%obj.horseStackMode)
	{
		%obj.clearMoveX();
		%obj.setJumping(1);
		%obj.horseStackMode = 0;
		return;
	}
	if(%obj.horseLastDirAttempts >= 3)
		%obj.horseLastDir = 0;
	
	%scale = getWord(%obj.getScale(),0);

	%pos = vectorAdd(%obj.getPosition(),"0 0" SPC 0.8*%scale);
	%vec = %obj.getForwardVector();
	
	%xVec = getWord(%vec, 0);
	%yVec = getWord(%vec, 1);

	%mask = $TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType;
	

	%dist = 5*%scale;
	%sDist = 3*%scale;
	//Forward Check
	%fPos = vectorAdd(%pos,vectorScale(%vec,%dist));//5

	%target = ContainerRayCast(%pos, %fPos, %mask,%obj);
	if(%target)
	{
		%blockingBrick = 0;
	
		if( %target.getType() & $TypeMasks::FxBrickObjectType )
		{
			// if we encounter a brick remember it
			%blockingBrick = %target;
				
		}
		else if( %target.getClassName() $= "AIPlayer" && %target.getDatablock().getName() !$= "NewHorseArmor" )// && getWord(%playerPos,2) > getWord(%obj.getPosition(),2)+2)
		{
			%obj.clearMoveX();
			%obj.horseJump();
		}
		else if( %target.getClassName() $= "Player" )
		{
			%forwardBlockPlayer = 1;
		}

		%forwardBlocked = 1;

		if( %target.getDatablock().getName() $= "NewHorseArmor" )
		{
			%forwardBlocked = 0;
		}
	}
		
	if( !%forwardBlocked )
	{
		return;
	}

	//Left Check
	%sVec = -%yVec SPC %xVec SPC 0;
	%fPos = vectorAdd(%pos,vectorScale(%svec,%sDist));

	%target = ContainerRayCast(%pos, %fPos, %mask,%obj);
	if(%target)
	{
		// echo("left Blocked");
		%leftBlocked = 1;
	}

	//Right Check
	%sVec = %yVec SPC -%xVec SPC 0;
	%fPos = vectorAdd(%pos,vectorScale(%svec,%sDist));

	%target = ContainerRayCast(%pos, %fPos, %mask,%obj);
	if(%target)
	{
		// echo("Right Blocked");
		%rightBlocked = 1;
	}

	//Up Jump Check
	%target = ContainerRayCast(%pos, vectorAdd(%pos,"0 0" SPC 5*%scale), %mask,%obj);
	if(%target)
	{
		//echo("Jump Blocked");
		//If there's an bot above me tell him to jump up so we can get that bastard
		if(isObject(%target) && %target.getClassName() $= "AIPlayer")
		{
			%obj.clearMoveX();
			%obj.horseJump();
			%leftBlocked = 1;
			%rightBlocked = 1;
			
			%target.clearMoveX();
			%target.horseJump();
			%target.horseStackMode = 1;
		}
		
		%jumpBlocked = 1;
	}

	//Can I jump it?
	
	// temporary hack for the horse, since I don't exactly know howt he jump formula works in torque
	%unitPerForce = 0.004;
		
	%jumpHeight = %unitPerForce * %data.jumpForce;
	
	%pos = vectorAdd(%pos,"0 0" SPC %jumpHeight*%scale);
	%fPos = vectorAdd(%pos,vectorScale(%vec,%dist));

	%target = ContainerRayCast(%pos, %fPos, %mask,%obj);
	if(%target)
	{
		// %target.setColor(0);
		// echo("Too High to jump");
		%canJump = 0;
		//if it's a player or bot try to jump if he's blocking our way
		if(%target.getClassName() $= "player") 
			%canJump = 1;

		if(%target.getClassName() $= "AIPlayer" && %target.getDatablock().getName() !$= "NewHorseArmor") 
			%canJump = 1;
		
		//Random jumping always good as well
		if(!getRandom(0,2) && %target.getDatablock().getName() !$= "NewHorseArmor") 
			%canJump = 1;
	}
	
	if(%forwardBlocked && !%avoided && !%jumpBlocked && %canJump && !%forwardBlockPlayer)
	{
		//if in water we need to hold jump a bit longer so we can get out, this causes some problems with sea based bots, bot overall it works good
		if(%obj.getWaterCoverage() && %data.drag >= 0.05)
			%obj.horseJump();
		else
			%obj.horseJump(150);
		
		//return;
		%hasJumped = 1;
		
		%obj.horseAvoidJumpTries++;
	}
	else
		%obj.horseAvoidJumpTries = 0;
		
	if(%forwardBlocked && ( !%hasJumped || %obj.horseAvoidJumpTries > 2 ))
	{
		%obj.horseAvoidJumpTries = 0;

		if(!%rightBlocked && !%leftBlocked)
		{
			//Check if we're already going one way, good for long walls
			if(%obj.horseLastDir)
			{
				%obj.setMoveX(%obj.horseLastDir);
				%avoided = 1;
				%obj.horseLastDirAttempts++;
			}
			else
			{
				%chance = getRandom(1,2);
				if(!getRandom(0,1))
					%obj.horseLastDir = %chance;

				switch (%chance)
				{
					case 1: %obj.setMoveX(1);		
					case 2: %obj.setMoveX(-1);
				}
				%avoided = 1;
			}
		}
		else if(!%leftBlocked)
		{
			%avoided = 1;
			%obj.setMoveX(-1);
		}
		else if(!%rightBlocked)
		{
			%avoided = 1;
			%obj.setMoveX(1);
		}
	}

	//Check if the bot is stuck
	if( vectorDist(%obj.horseLastPosition, %obj.getPosition()) < 2*%scale && !%obj.horseLastMoveRandom )
	{
		//echo("I'm stuck!");
		%following = %obj.getAimObject();
		if(isObject(%following) && vectorDist(%pos, %following.getPosition()) <= 12)
		{
			%obj.horseLastMoveRandom = 0;
			return;
		}
		%obj.horseLastMoveRandom = 1;
		%obj.horseClearMovement();
		%xRand = getrandom(-10,10);
		%yRand = getrandom(-10,10);
		
		%fPos = %obj.horseReturnForwardBackPos(-15);

		%obj.setMoveDestination( vectoradd(%fPos,%xRand SPC %yRand SPC 0) );
		return;
	}
	%obj.horseLastMoveRandom = 0;
	%obj.horseLastPosition = %obj.getPosition();
}

if(isPackage(NewHorsePackage))
{
	deactivatePackage(NewHorsePackage);
}

package NewHorsePackage
{
	function Armor::onMount(%this, %obj, %col, %slot)
	{
		Parent::onMount(%this, %obj, %col, %slot);
		if(%col.getDatablock().getName() $= "NewHorseArmor" && %slot == 2)
		{
			%col.getDatablock().playNeigh(%col);
		}
	}

	function Armor::onTrigger(%this, %obj, %slot, %val)
	{
		if(%obj.getClassName() $= "AIPlayer" && %slot == 2 && %obj.getDatablock().getName() $= "NewHorseArmor" && %val)
		{
			%obj.isJumping = true;
			%obj.stopAudio(0);

			%obj.getDatablock().horseSoundCheck(%obj);
		}
		return Parent::onTrigger(%this, %obj, %slot, %val);
	}

	function AIPlayer::playPain(%this)
	{
		if(%this.getDatablock().getName() $= "NewHorseArmor")
		{
			%this.getDatablock().playNeigh(%this);
			return;
		}

		Parent::playPain(%this);
	}

	function AIPlayer::playDeathCry(%this)
	{
		if(%this.getDatablock().getName() $= "NewHorseArmor")
		{
			%this.getDatablock().playNeigh(%this);
			return;
		}

		Parent::playDeathCry(%this);
	}

	function Player::mountImage(%this, %slot, %image)
	{
		Parent::mountImage(%this, %slot, %image);
	}

	function Player::unmountImage(%this, %slot)
	{
		Parent::unmountImage(%this, %slot);
	}

	function AIPlayer::mountObject(%this, %obj, %slot)
	{
		Parent::mountObject(%this, %obj, %slot);

		%thread = %this.getDataBlock().mountThread[%slot];

		if (%thread $= "") {
			%thread = "root";
		}

		%obj.setActionThread(%thread);

		if(%this.getDataBlock().getName() $= "NewHorseArmor")
		{
			if(%this.foal || %this.mating)
			{
				%this.getDatablock().playNeigh(%this);
				if(isObject(HateImage)) %this.emote(HateImage);
				%obj.getDatablock().schedule(getRandom(100, 300), doDismount, %obj, 1);
				return;
			}

			%this.getDatablock().horseFollow(%this, 0);

			if(%slot == 2)
			{
				%this.lastRider = %obj;
			}
		}
	}

	function AIPlayer::unmountObject(%this, %obj)
	{
		Parent::unmountObject(%this, %obj);
	
		if(%this.getDataBlock().getName() $= "NewHorseArmor")
		{
			%obj.setControlObject(%obj);
		}
	}

	function serverCmdNextSeat(%this)
	{
		if(!isObject(%this.player))
		{
			return;
		}

		if(!isObject(%obj = %this.player.getObjectMount()))
		{
			return;
		}

		if(%obj.getDatablock().getName() $= "NewHorseArmor")
		{
			%db = %obj.getDatablock();

			for(%a = 0; %a < 2; %a++)
			{
				%rider = %obj.getMountNodeObject(%db.mountNode[%a]);

				if(isObject(%rider))
				{
					if(%rider $= %this.player)
					{
						%currSeat = %a;
					}
				}
				else
				{
					%freeSeats++;
				}
			}

			if(%freeSeats < 1)
			{
				return;
			}

			%newSeat = !%currSeat;

			%obj.mountObject(%this.player, %db.mountNode[%newSeat]);
			if(!%newSeat)
			{
				%this.player.setControlObject(%obj);
			}

			return;
		}

		Parent::serverCmdNextSeat(%this);
	}

	function serverCmdPrevSeat(%this)
	{
		if(!isObject(%this.player))
		{
			return;
		}

		if(!isObject(%obj = %this.player.getObjectMount()))
		{
			return;
		}

		if(%obj.getDatablock().getName() $= "NewHorseArmor")
		{
			%db = %obj.getDatablock();

			for(%a = 0; %a < 2; %a++)
			{
				%rider = %obj.getMountNodeObject(%db.mountNode[%a]);

				if(isObject(%rider))
				{
					if(%rider $= %this.player)
					{
						%currSeat = %a;
					}
				}
				else
				{
					%freeSeats++;
				}
			}

			if(%freeSeats < 1)
			{
				return;
			}

			%newSeat = !%currSeat;

			%obj.mountObject(%this.player, %db.mountNode[%newSeat]);
			if(!%newSeat)
			{
				%this.player.setControlObject(%obj);
			}

			return;
		}

		Parent::serverCmdPrevSeat(%this);
	}

	function Player::ActivateStuff(%obj)
	{
		Parent::ActivateStuff(%obj);
		
		%eye = %obj.getEyePoint();

		%target = ContainerRayCast( %eye, vectorAdd(%eye, vectorScale(%obj.getEyeVector(),5)), $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType, %obj );

		if( %target )
		{
			%target = %target.getID();

			if(%target.getDatablock().getName() $= "NewHorseArmor")
			{
				%target.getDatablock().onHorseClicked(%target, %obj);
			}
		}
	}

	function fxDTSBrick::setColor(%this, %colorID)
	{
		Parent::setColor(%this, %colorID);

		if(isObject(%this.vehicle) && %this.vehicle.getDatablock().getName() $= "NewHorseArmor")
		{
			%this.vehicle.saveColor();
		}
	}

	function fxDTSBrick::setVehicle(%this, %vehicle)
	{
		if(%vehicle.getName() $= "NewHorseArmor")
		{
			%this.setRecolorVehicle(true);
		}

		Parent::setVehicle(%this, %vehicle);
	}
};

activatePackage(NewHorsePackage);